//===================================================== file = mux_sel.c ======
//=  Mux re-assembly algorithm for VIQ PPS switch simulation model            =
//=============================================================================
//=  Contains: mux_sel()                                                      =
//=---------------------------------------------------------------------------=
//=  History: AAS (04/01/03) - Genesis                                        =
//=============================================================================
#define EXTERNAL        // This is an external file (used in common.h)

//----- Include files ---------------------------------------------------------
#include "csim.h"       // Needed for CSIM
#include "common.h"     // Needed for common stuff

void mux_sel(int out_id)
{
  int j;                // Generic loop counter
  int next_plane[N];    // Index of next VIQ (by flow)
  int temp_flag;        // Boolean flag

  create("mux_sel");

  // Initialization the variables
  for(j=0;j<N;j++)
    next_plane[j]=0;

  // Infinite Loop
  while(TRUE)
  {
    temp_flag=FALSE;
    for(j=0;j<N;j++)
    {
      // Checking presence of next cell of an inport-outport flow
      if(queue_cnt(Q_event[next_plane[j]][j][out_id])>0)
      {
        set(Q_event[next_plane[j]][j][out_id]);
        hold(CELL_TIME);
        temp_flag=TRUE;
        next_plane[j] = (next_plane[j]+1)%(K);
      }
    }

    // If no cell is selected (all VIQs are empty), wait for empty cell slot
    if(temp_flag==FALSE)
      hold(CELL_TIME);
  }
}
