//====================================================== file = outport.c =====
//=  Output port for VIQ PPS switch simulation model                          =
//=============================================================================
//=  Contains: outport()                                                      =
//=---------------------------------------------------------------------------=
//=  History: AAS (04/01/03) - Genesis                                        =
//=============================================================================
#define EXTERNAL        // This is an external file (used in common.h)

//----- Include files ---------------------------------------------------------
#include "csim.h"       // Needed for CSIM
#include "common.h"     // Needed for common stuff

void outport(int from_id,int out_id,int channel_num,int tag,double org_time)
{

  create("outport");

  // Queueing cell at internal outport links
  reserve(Outport_internal[channel_num][out_id]);
  hold(K * CELL_TIME);
  release(Outport_internal[channel_num][out_id]);

  // Forward cell to the outport multiplexor
  outmux[out_id](from_id,out_id,channel_num,tag,org_time);
  return;
}
